/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.57 from the
 * contents of Int128.xs. Do not edit this file, edit Int128.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Int128.xs"
/* -*- Mode: C -*- */

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#include <stdint.h>
#include "perl_math_int64.h"

#ifdef INT128_TI
typedef int int128_t __attribute__ ((__mode__ (TI)));
typedef unsigned int uint128_t __attribute__ ((__mode__ (TI)));
#define HAVE_INT128
#endif

#ifdef __INT128
typedef __int128 int128_t;
typedef unsigned __int128 uint128_t;
#define HAVE_INT128
#endif

#ifndef HAVE_INT128
#error "No int128 type define was passed to the compiler!"
#endif

/* perl memory allocator does not guarantee 16-byte alignment */
typedef int128_t int128_t_a8 __attribute__ ((aligned(8)));
typedef uint128_t uint128_t_a8 __attribute__ ((aligned(8)));

#define I128LEN sizeof(int128_t)

#define INT128_MAX ((int128_t)((~(uint128_t)0)>>1))
#define INT128_MIN (~INT128_MAX)
#define UINT128_MAX ((uint128_t)(~(uint128_t)0))

static int may_die_on_overflow = 0;

#if (PERL_VERSION >= 10)

#ifndef cop_hints_fetch_pvs
#define cop_hints_fetch_pvs(cop, key, flags) \
    Perl_refcounted_he_fetch(aTHX_ (cop)->cop_hints_hash, NULL, STR_WITH_LEN(key), (flags), 0)
#endif

static int
check_die_on_overflow_hint(pTHX) {
    SV *hint = cop_hints_fetch_pvs(PL_curcop, "Math::Int128::die_on_overflow", 0);
    return (hint && SvTRUE(hint));
}

#else

static int
check_die_on_overflow_hint(pTHX) {
    return 1;
}

#endif

static void
overflow(pTHX_ const char *msg) {
    if (check_die_on_overflow_hint(aTHX))
        Perl_croak(aTHX_ "Math::Int128 overflow: %s", msg);
}

#define get_int128_stash_uncached() gv_stashpvs("Math::Int128", 1)
#define get_uint128_stash_uncached() gv_stashpvs("Math::UInt128", 1)

#ifdef MULTIPLICITY
#  if defined(I_PTHREAD) && defined(PTHREAD_MUTEX_INITIALIZER)
#    define CACHE_STASHES
#  endif
#else
#  define CACHE_STASHES
#endif

#ifdef CACHE_STASHES
static HV * volatile int128_stash;
static HV * volatile uint128_stash;

#  ifdef MULTIPLICITY
static pthread_mutex_t stash_mutex = PTHREAD_MUTEX_INITIALIZER;
static int too_many_threads = 0;

static void init_stash_cache(pTHX) {
    pthread_mutex_lock(&stash_mutex);
    if (too_many_threads) {
        int128_stash = NULL;
        uint128_stash = NULL;
    }
    else {
        too_many_threads = 1;
        int128_stash = get_int128_stash_uncached();
        uint128_stash = get_uint128_stash_uncached();
    }
    pthread_mutex_unlock(&stash_mutex);
}

#  else

static void init_stash_cache(pTHX) {
    int128_stash = get_int128_stash_uncached();
    uint128_stash = get_uint128_stash_uncached();
}

#  endif

#define get_int128_stash() (int128_stash ? int128_stash : get_int128_stash_uncached())
#define get_uint128_stash() (uint128_stash ? uint128_stash : get_uint128_stash_uncached())

#else

static void init_stash_cache(pTHX) { }

#define get_int128_stash get_int128_stash_uncached
#define get_uint128_stash get_uint128_stash_uncached

#endif

static char *out_of_bounds_error_s = "Number is out of bounds for int128_t conversion";
static char *out_of_bounds_error_u = "Number is out of bounds for uint128_t conversion";
static char *mul_error             = "Multiplication overflows";
static char *pow_error             = "Exponentiation overflows";
static char *add_error             = "Addition overflows";
static char *sub_error             = "Subtraction overflows";
static char *inc_error             = "Increment operation wraps";
static char *dec_error             = "Decrement operation wraps";
static char *div_by_0_error        = "Illegal division by zero";

static void croak_string(pTHX_ const char *str) {
    Perl_croak(aTHX_ "%s", str);
}

#include "strtoint128.h"

#define SvI128Y(sv) (*((int128_t_a8*)SvPVX(sv)))
#define SvU128Y(sv) (*((uint128_t_a8*)SvPVX(sv)))
#define SVt_I128 SVt_PV

static SV *
new_si128(pTHX) {
    SV *si128 = newSV(I128LEN);
    SvPOK_on(si128);
    SvCUR_set(si128, I128LEN);
    return si128;
}

#define new_su128 new_si128

static SV *
newSVi128(pTHX_ int128_t i128) {
    HV *stash = get_int128_stash();
    SV *si128 = new_si128(aTHX);
    SV *sv;
    SvI128Y(si128) = i128;
    sv = newRV_noinc(si128);
    sv_bless(sv, stash);
    SvREADONLY_on(si128);
    return sv;
}

static SV *
newSVu128(pTHX_ uint128_t u128) {
    HV *stash = get_uint128_stash();
    SV *su128 = new_su128(aTHX);
    SV *sv;
    SvI128Y(su128) = u128;
    sv = newRV_noinc(su128);
    sv_bless(sv, stash);
    SvREADONLY_on(su128);
    return sv;
}

static int
SvI128OK(pTHX_ SV *sv) {
    if (SvROK(sv)) {
        SV *si128 = SvRV(sv);
        return (si128 && (SvTYPE(si128) >= SVt_I128) && sv_isa(sv, "Math::Int128"));
    }
    return 0;
}

static int
SvU128OK(pTHX_ SV *sv) {
    if (SvROK(sv)) {
        SV *su128 = SvRV(sv);
        return (su128 && (SvTYPE(su128) >= SVt_I128) && sv_isa(sv, "Math::UInt128"));
    }
    return 0;
}

#define SvI128X(sv) (SvI128Y(SvRV(sv)))
#define SvU128X(sv) (SvU128Y(SvRV(sv)))

static SV *
SvSI128(pTHX_ SV *sv) {
    if (SvROK(sv)) {
        SV *si128 = SvRV(sv);
        if (SvPOK(si128) && (SvCUR(si128) == I128LEN))
            return si128;
    }
    croak_string(aTHX_ "internal error: reference to int128_t expected");
    return NULL; /* never happens */
}

static SV *
SvSU128(pTHX_ SV *sv) {
    if (SvROK(sv)) {
        SV *su128 = SvRV(sv);
        if (SvPOK(su128) && (SvCUR(su128) == I128LEN))
            return su128;
    }
    croak_string(aTHX_ "internal error: reference to uint128_t expected");
    return NULL; /* never happens */
}

#define SvI128x(sv) SvI128Y(SvSI128(aTHX_ sv))
#define SvU128x(sv) SvU128Y(SvSU128(aTHX_ sv))

static int128_t
SvI128(pTHX_ SV *sv) {
    STRLEN len;
    char *pv;
    if (SvROK(sv)) {
        SV *si128 = SvRV(sv);
        if (si128 && SvOBJECT(si128)) {
            HV *stash = SvSTASH(si128);
#ifdef CACHE_STASHES
            if (stash == int128_stash) {
                return SvI128Y(si128);
            }
            else if (stash == uint128_stash) {
                int128_t u128 = SvU128Y(si128);
                if (may_die_on_overflow && (u128 > INT128_MAX))
                    overflow(aTHX_ out_of_bounds_error_s);
                return u128;
            }
#else
            if (0);
#endif
            else {
                GV *method;
                char const * classname = HvNAME_get(stash);
                if (memcmp(classname, "Math::", 6) == 0) {
                    int u;
                    if (classname[6] == 'U') {
                        classname += 7;
                        u = 1;
                    }
                    else {
                        classname += 6;
                        u = 0;
                    }
                    if (memcmp(classname, "Int", 3) == 0) {
                        classname += 3;
                        if (memcmp(classname, "128", 4) == 0) {
                            if (!SvPOK(si128) || (SvCUR(si128) != I128LEN))
                                Perl_croak(aTHX_ "Wrong internal representation for %s object", HvNAME_get(stash));
                            if (u) {
                                int128_t u128 = SvU128Y(si128);
                                if (may_die_on_overflow && (u128 > INT128_MAX))
                                    overflow(aTHX_ out_of_bounds_error_s);
                                return u128;
                            }
                            return SvI128Y(si128);
                        }
                        if (memcmp(classname, "64", 3) == 0) {
                            if (u) {
                                return SvU64(sv);
                            }
                            return SvI64(sv);
                        }
                    }
                }
                method = gv_fetchmethod(stash, "as_int128");
                if (method) {
                    SV *result;
                    int count;
                    dSP;
                    ENTER;
                    SAVETMPS;
                    PUSHSTACKi(PERLSI_MAGIC);
                    PUSHMARK(SP);
                    XPUSHs(sv);
                    PUTBACK;
                    count = perl_call_sv( (SV*)method, G_SCALAR );
                    SPAGAIN;
                    if (count != 1)
                        Perl_croak(aTHX_ "internal error: method call returned %d values, 1 expected", count);
                    result = newSVsv(POPs);
                    PUTBACK;
                    POPSTACK;
                    SPAGAIN;
                    FREETMPS;
                    LEAVE;
                    return SvI128(aTHX_ sv_2mortal(result));
                }
            }
        }
    }
    else {
        SvGETMAGIC(sv);
        if (SvIOK(sv)) {
            if (SvIOK_UV(sv))
                return SvUV(sv);
            return SvIV(sv);
        }
        if (SvNOK(sv)) {
            NV nv = SvNV(sv);
            if (may_die_on_overflow &&
                ((nv >= 0x1p127) || (nv < -0x1p127))) overflow(aTHX_ out_of_bounds_error_s);
            return nv;
        }
    }
    pv = SvPV(sv, len);
    return strtoint128(aTHX_ pv, len, 10, 1);
}

static uint128_t
SvU128(pTHX_ SV *sv) {
    STRLEN len;
    char *pv;
    if (SvROK(sv)) {
        SV *su128 = SvRV(sv);
        if (su128 && SvOBJECT(su128)) {
            HV *stash = SvSTASH(su128);
#ifdef CACHE_STASHES
            if (stash == uint128_stash)
                return SvU128Y(su128);
            else if (stash == int128_stash) {
                int128_t i128 = SvI128Y(su128);
                if (may_die_on_overflow && (i128 < 0))
                    overflow(aTHX_ out_of_bounds_error_u);
                return i128;
            }
#else
            if (0);
#endif
            else {
                GV *method;
                char const * classname = HvNAME_get(stash);
                if (memcmp(classname, "Math::", 6) == 0) {
                    int u;
                    if (classname[6] == 'U') {
                        classname += 7;
                        u = 1;
                    }
                    else {
                        classname += 6;
                        u = 0;
                    }
                    if (memcmp(classname, "Int", 3) == 0) {
                        classname += 3;
                        if (memcmp(classname, "128", 4) == 0) {
                            if (!SvPOK(su128) || (SvCUR(su128) != I128LEN))
                                Perl_croak(aTHX_ "Wrong internal representation for %s object", HvNAME_get(stash));
                            if (u)
                                return SvU128Y(su128);
                            else {
                                int128_t i128 = SvI128Y(su128);
                                if (may_die_on_overflow && (i128 < 0)) overflow(aTHX_ out_of_bounds_error_u);
                                return i128;
                            }
                        }
                        if (memcmp(classname, "64", 3) == 0) {
                            if (u) {
                                return SvU64(sv);
                            }
                            else {
                                int64_t i64 = SvI64(sv);
                                if (may_die_on_overflow && (i64 < 0)) overflow(aTHX_ out_of_bounds_error_u);
                                return i64;
                            }
                        }
                    }
                }
                method = gv_fetchmethod(stash, "as_uint128");
                if (method) {
                    SV *result;
                    int count;
                    dSP;
                    ENTER;
                    SAVETMPS;
                    PUSHSTACKi(PERLSI_MAGIC);
                    PUSHMARK(SP);
                    XPUSHs(sv);
                    PUTBACK;
                    count = perl_call_sv( (SV*)method, G_SCALAR );
                    SPAGAIN;
                    if (count != 1)
                        Perl_croak(aTHX_ "internal error: method call returned %d values, 1 expected", count);
                    result = newSVsv(POPs);
                    PUTBACK;
                    POPSTACK;
                    SPAGAIN;
                    FREETMPS;
                    LEAVE;
                    return SvU128(aTHX_ sv_2mortal(result));
                }
            }
        }
    }
    else {
        SvGETMAGIC(sv);
        if (SvIOK(sv)) {
            if (SvIOK_UV(sv))
                return SvUV(sv);
            else {
                IV iv = SvIV(sv);
                if (may_die_on_overflow && (iv < 0)) overflow(aTHX_ out_of_bounds_error_u);
                return iv;
            }
        }
        if (SvNOK(sv)) {
            NV nv = SvNV(sv);
            if (may_die_on_overflow && ((nv < 0) || (nv >= 0x1p128))) overflow(aTHX_ out_of_bounds_error_u);
            return nv;
        }
    }
    pv = SvPV(sv, len);
    return strtoint128(aTHX_ pv, len, 10, 0);
}

static SV *
si128_to_number(pTHX_ SV *sv) {
    int128_t i128 = SvI128(aTHX_ sv);
    if (i128 < 0) {
        IV iv = i128;
        if (iv == i128)
            return newSViv(iv);
    }
    else {
        UV uv = i128;
        if (uv == i128)
            return newSVuv(uv);
    }
    return newSVnv(i128);
}

static SV *
su128_to_number(pTHX_ SV *sv) {
    uint128_t u128 = SvU128(aTHX_ sv);
    UV uv;
    uv = u128;
    if (uv == u128)
        return newSVuv(uv);
    return newSVnv(u128);
}

#define I128STRLEN 44

static STRLEN
u128_to_string(uint128_t u128, char *to) {
    char str[I128STRLEN];
    int i, len = 0;
    while (u128) {
        str[len++] = '0' + u128 % 10;
        u128 /= 10;
    }
    if (len) {
        for (i = len; i--;) *(to++) = str[i];
        return len;
    }
    else {
        to[0] = '0';
        return 1;
    }
}

static STRLEN
i128_to_string(int128_t i128, char *to) {
    if (i128 < 0) {
        *(to++) = '-';
        return u128_to_string(-i128, to) + 1;
    }
    return u128_to_string(i128, to);
}

static void
u128_to_hex(uint128_t i128, char *to) {
    int i = I128LEN * 2;
    while (i--) {
        int v = i128 & 15;
        to[i] = v + ((v > 9) ? ('A' - 10) : '0');
        i128 >>= 4;
    }
}

static void
mul_check_overflow(pTHX_ uint128_t a, uint128_t b, const char *error_str) {
    if (a < b) {
        uint128_t tmp = a;
        a = b; b = tmp;
    }
    if (b > UINT64_MAX) overflow(aTHX_ error_str);
    else {
        uint128_t rl, rh;
        rl = (a & UINT64_MAX) * b;
        rh = (a >> 64) * b + (rl >> 64);
        if (rh > UINT64_MAX) overflow(aTHX_ error_str);
    }
}

static uint128_t
powU128(pTHX_ uint128_t a, uint128_t b) {
    uint128_t r;
    int mdoo = may_die_on_overflow;
    if (b == 0) return 1;
    if (b == 1) return a;
    if (b == 2) {
        if (mdoo && (a > UINT64_MAX)) overflow(aTHX_ pow_error);
        return a*a;
    }
    if (a == 0) return 0;
    if (a == 1) return 1;
    if (a == 2) {
        if (b > 127) {
            if (mdoo) overflow(aTHX_ pow_error);
            return 0;
        }
        return (((uint128_t)1) << b);
    }
    if (mdoo) {
        r = ((b & 1) ? a : 1);
        while ((b >>= 1)) {
            if (a > UINT64_MAX) overflow(aTHX_ pow_error);
            a *= a;
            if (b & 1) {
                mul_check_overflow(aTHX_ r, a, pow_error);
                r *= a;
            }
        }
    }
    else {
        r = 1;
        while (b) {
            if (b & 1) r *= a;
            a *= a;
            b >>= 1;
        }
    }
    return r;
}

#include "c_api.h"

#line 560 "Int128.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

/* simple backcompat versions of the TARGx() macros with no optimisation */
#ifndef TARGi
#  define TARGi(iv, do_taint) sv_setiv_mg(TARG, iv)
#  define TARGu(uv, do_taint) sv_setuv_mg(TARG, uv)
#  define TARGn(nv, do_taint) sv_setnv_mg(TARG, nv)
#endif

#line 711 "Int128.c"

XS_EUPXS(XS_Math__Int128_CLONE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_CLONE)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 560 "Int128.xs"
    init_stash_cache(aTHX);
    RETVAL = 1;
#line 725 "Int128.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__set_may_die_on_overflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__set_may_die_on_overflow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "v");
    {
	int	v = (int)SvIV(ST(0))
;
#line 569 "Int128.xs"
    may_die_on_overflow = v;
#line 744 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "value=0");
    {
	SV *	value;
	SV *	RETVAL;

	if (items < 1)
	    value = 0;
	else {
	    value = ST(0)
;
	}
#line 575 "Int128.xs"
    RETVAL = newSVi128(aTHX_ (value ? SvI128(aTHX_ value) : 0));
#line 768 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_uint128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "value=0");
    {
	SV *	value;
	SV *	RETVAL;

	if (items < 1)
	    value = 0;
	else {
	    value = ST(0)
;
	}
#line 583 "Int128.xs"
    RETVAL = newSVu128(aTHX_ (value ? SvU128(aTHX_ value) : 0));
#line 794 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_int128_to_number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_to_number)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 591 "Int128.xs"
    RETVAL = si128_to_number(aTHX_ self);
#line 814 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_uint128_to_number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_to_number)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 599 "Int128.xs"
    RETVAL = su128_to_number(aTHX_ self);
#line 834 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_net_to_int128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_net_to_int128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	SV *	net = ST(0)
;
#line 607 "Int128.xs"
    STRLEN len;
    unsigned char *pv = (unsigned char *)SvPV(net, len);
#line 854 "Int128.c"
	SV *	RETVAL;
#line 610 "Int128.xs"
    if (len != 16)
        croak_string(aTHX_ "Invalid length for int128_t");
    RETVAL = newSVi128(aTHX_
                       (((((((((((((((((((((((((((((((int128_t)pv[0]) << 8)
                                                   + (int128_t)pv[1]) << 8)
                                                 + (int128_t)pv[2]) << 8)
                                               + (int128_t)pv[3]) << 8)
                                             + (int128_t)pv[4]) << 8)
                                           + (int128_t)pv[5]) << 8)
                                         + (int128_t)pv[6]) << 8)
                                       + (int128_t)pv[7]) << 8)
                                     + (int128_t)pv[8]) << 8)
                                   + (int128_t)pv[9]) << 8)
                                 + (int128_t)pv[10]) << 8)
                               + (int128_t)pv[11]) << 8)
                             + (int128_t)pv[12]) << 8)
                           + (int128_t)pv[13]) << 8)
                         + (int128_t)pv[14]) << 8)
                       + (int128_t)pv[15]);
#line 876 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_net_to_uint128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_net_to_uint128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	SV *	net = ST(0)
;
#line 636 "Int128.xs"
    STRLEN len;
    unsigned char *pv = (unsigned char *)SvPV(net, len);
#line 896 "Int128.c"
	SV *	RETVAL;
#line 639 "Int128.xs"
    if (len != 16)
        croak_string(aTHX_ "Invalid length for uint128_t");
    RETVAL = newSVu128(aTHX_
                       (((((((((((((((((((((((((((((((uint128_t)pv[0]) << 8)
                                                   + (uint128_t)pv[1]) << 8)
                                                 + (uint128_t)pv[2]) << 8)
                                               + (uint128_t)pv[3]) << 8)
                                             + (uint128_t)pv[4]) << 8)
                                           + (uint128_t)pv[5]) << 8)
                                         + (uint128_t)pv[6]) << 8)
                                       + (uint128_t)pv[7]) << 8)
                                     + (uint128_t)pv[8]) << 8)
                                   + (uint128_t)pv[9]) << 8)
                                 + (uint128_t)pv[10]) << 8)
                               + (uint128_t)pv[11]) << 8)
                             + (uint128_t)pv[12]) << 8)
                           + (uint128_t)pv[13]) << 8)
                         + (uint128_t)pv[14]) << 8)
                       + (uint128_t)pv[15]);
#line 918 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_int128_to_net); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_to_net)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 665 "Int128.xs"
    char *pv;
    int128_t i128 = SvI128(aTHX_ self);
    int i;
#line 939 "Int128.c"
	SV *	RETVAL;
#line 669 "Int128.xs"
    RETVAL = newSV(I128LEN);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, I128LEN);
    pv = SvPVX(RETVAL);
    pv[I128LEN] = '\0';
    for (i = I128LEN - 1; i >= 0; i--, i128 >>= 8)
        pv[i] = i128;
#line 949 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_uint128_to_net); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_to_net)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 683 "Int128.xs"
    char *pv;
    uint128_t u128 = SvU128(aTHX_ self);
    int i;
#line 970 "Int128.c"
	SV *	RETVAL;
#line 687 "Int128.xs"
    RETVAL = newSV(I128LEN);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, I128LEN);
    pv = SvPVX(RETVAL);
    pv[I128LEN] = '\0';
    for (i = I128LEN - 1; i >= 0; i--, u128 >>= 8)
        pv[i] = u128;
#line 980 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_native_to_int128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_native_to_int128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "native");
    {
	SV *	native = ST(0)
;
#line 701 "Int128.xs"
    STRLEN len;
    char *pv = SvPV(native, len);
#line 1000 "Int128.c"
	SV *	RETVAL;
#line 704 "Int128.xs"
    if (len != I128LEN)
        croak_string(aTHX_ "Invalid length for int128_t");
    RETVAL = newSVi128(aTHX_ 0);
    Copy(pv, &(SvI128X(RETVAL)), I128LEN, char);
#line 1007 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_native_to_uint128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_native_to_uint128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "native");
    {
	SV *	native = ST(0)
;
#line 715 "Int128.xs"
    STRLEN len;
    char *pv = SvPV(native, len);
#line 1027 "Int128.c"
	SV *	RETVAL;
#line 718 "Int128.xs"
    if (len != I128LEN)
        croak_string(aTHX_ "Invalid length for uint128_t");
    RETVAL = newSVu128(aTHX_ 0);
    Copy(pv, &(SvU128X(RETVAL)), I128LEN, char);
#line 1034 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_int128_to_native); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_to_native)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 729 "Int128.xs"
    char *pv;
    int128_t i128 = SvI128(aTHX_ self);
#line 1054 "Int128.c"
	SV *	RETVAL;
#line 732 "Int128.xs"
    RETVAL = newSV(I128LEN);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, I128LEN);
    pv = SvPVX(RETVAL);
    Copy(&i128, pv, I128LEN, char);
    pv[I128LEN] = '\0';
#line 1063 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_uint128_to_native); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_to_native)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 745 "Int128.xs"
    char *pv;
    uint128_t u128 = SvU128(aTHX_ self);
#line 1083 "Int128.c"
	SV *	RETVAL;
#line 748 "Int128.xs"
    RETVAL = newSV(I128LEN);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, I128LEN);
    pv = SvPVX(RETVAL);
    Copy(&u128, pv, I128LEN, char);
    pv[I128LEN] = '\0';
#line 1092 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_uint128_to_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_to_hex)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 761 "Int128.xs"
    char *pv;
    uint128_t u128 = SvU128(aTHX_ self);
#line 1112 "Int128.c"
	SV *	RETVAL;
#line 764 "Int128.xs"
    RETVAL = newSV(I128LEN * 2);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, I128LEN * 2);
    pv = SvPVX(RETVAL);
    u128_to_hex(u128, pv);
#line 1120 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_int128_to_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_to_hex)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 776 "Int128.xs"
    char *pv;
    uint128_t u128 = SvI128(aTHX_ self);
#line 1140 "Int128.c"
	SV *	RETVAL;
#line 779 "Int128.xs"
    RETVAL = newSV(I128LEN * 2);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, I128LEN * 2);
    pv = SvPVX(RETVAL);
    u128_to_hex(u128, pv);
#line 1148 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_string_to_int128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_string_to_int128)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sv, base = 0");
    {
	SV *	sv = ST(0)
;
	int	base;
#line 792 "Int128.xs"
    const char *pv;
    STRLEN len;
#line 1169 "Int128.c"
	SV *	RETVAL;

	if (items < 2)
	    base = 0;
	else {
	    base = (int)SvIV(ST(1))
;
	}
#line 795 "Int128.xs"
    pv = SvPV(sv, len);
    RETVAL = newSVi128(aTHX_ strtoint128(aTHX_ pv, len, base, 1));
#line 1181 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_string_to_uint128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_string_to_uint128)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sv, base = 0");
    {
	SV *	sv = ST(0)
;
	int	base;
#line 805 "Int128.xs"
    const char *pv;
    STRLEN len;
#line 1202 "Int128.c"
	SV *	RETVAL;

	if (items < 2)
	    base = 0;
	else {
	    base = (int)SvIV(ST(1))
;
	}
#line 808 "Int128.xs"
    pv = SvPV(sv, len);
    RETVAL = newSVu128(aTHX_ strtoint128(aTHX_ pv, len, base, 0));
#line 1214 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__inc)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
#line 820 "Int128.xs"
    int128_t i128 = SvI128x(self);
#line 1233 "Int128.c"
	SV *	RETVAL;
#line 822 "Int128.xs"
    if (may_die_on_overflow && (i128 == INT128_MAX)) overflow(aTHX_ inc_error);
    SvI128x(self) = i128 + 1;
    RETVAL = self;
    SvREFCNT_inc(RETVAL);
#line 1240 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__dec)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
#line 833 "Int128.xs"
    int128_t i128 = SvI128x(self);
#line 1259 "Int128.c"
	SV *	RETVAL;
#line 835 "Int128.xs"
    if (may_die_on_overflow && (i128 == 0)) overflow(aTHX_ dec_error);
    SvI128x(self) = i128 - 1;
    RETVAL = self;
    SvREFCNT_inc(RETVAL);
#line 1266 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 848 "Int128.xs"
    int128_t a = SvI128x(self);
    int128_t b = SvI128(aTHX_ other);
#line 1290 "Int128.c"
	SV *	RETVAL;
#line 851 "Int128.xs"
    if ( may_die_on_overflow &&
         ( a > 0
           ? ( (b > 0) && (INT128_MAX - a < b) )
           : ( (b < 0) && (INT128_MIN - a > b) ) ) ) overflow(aTHX_ add_error);
    if (SvOK(rev)) 
        RETVAL = newSVi128(aTHX_ a + b);
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI128x(self) = a + b;
    }
#line 1304 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 871 "Int128.xs"
    int128_t a = SvI128x(self);
    int128_t b = SvI128(aTHX_ other);
#line 1328 "Int128.c"
	SV *	RETVAL;
#line 874 "Int128.xs"
    if (SvTRUE(rev)) {
        int128_t tmp = a;
        a = b; b = tmp;
    }
    if ( may_die_on_overflow &&
         ( a > 0
           ? ( (b < 0) && (a - INT128_MAX > b) )
           : ( (b > 0) && (a - INT128_MIN < b) ) ) ) overflow(aTHX_ sub_error);
    if (SvOK(rev))
        RETVAL = newSVi128(aTHX_ a - b);
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI128x(self) = a - b;
    }
#line 1346 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 898 "Int128.xs"
    int128_t a1 = SvI128x(self);
    int128_t b1 = SvI128(aTHX_ other);
#line 1370 "Int128.c"
	SV *	RETVAL;
#line 901 "Int128.xs"
    if (may_die_on_overflow) {
        int neg = 0;
        uint128_t a, b;
        if (a1 < 0) {
            a = -a1;
            neg ^= 1;
        }
        else a = a1;
        if (b1 < 0) {
            b = -b1;
            neg ^= 1;
        }
        else b = b1;
        mul_check_overflow(aTHX_ a, b, mul_error);
        if (a * b > (neg ? (~(uint128_t)INT128_MIN + 1) : INT128_MAX)) overflow(aTHX_ mul_error);
    }
    if (SvOK(rev))
        RETVAL = newSVi128(aTHX_ a1 * b1);
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI128x(self) = a1 * b1;
    }
#line 1396 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 933 "Int128.xs"
    int128_t up;
    int128_t down;
#line 1420 "Int128.c"
	SV *	RETVAL;
#line 936 "Int128.xs"
    if (SvOK(rev)) {
        if (SvTRUE(rev)) {
            up = SvI128(aTHX_ other);
            down = SvI128x(self);
        }
        else {
            up = SvI128x(self);
            down = SvI128(aTHX_ other);
        }
        if (!down)
            croak_string(aTHX_ div_by_0_error);
        RETVAL = newSVi128(aTHX_ up/down);
    }
    else {
        down = SvI128(aTHX_ other);
        if (!down)
            croak_string(aTHX_ div_by_0_error);
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI128x(self) /= down;
    }
#line 1444 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__remainder); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__remainder)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 966 "Int128.xs"
    int128_t up;
    int128_t down;
#line 1468 "Int128.c"
	SV *	RETVAL;
#line 969 "Int128.xs"
    if (SvOK(rev)) {
        if (SvTRUE(rev)) {
            up = SvI128(aTHX_ other);
            down = SvI128x(self);
        }
        else {
            up = SvI128x(self);
            down = SvI128(aTHX_ other);
        }
        if (!down)
            croak_string(aTHX_ div_by_0_error);
        RETVAL = newSVi128(aTHX_ up % down);
    }
    else {
        down = SvI128(aTHX_ other);
        if (!down)
            croak_string(aTHX_ div_by_0_error);
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI128x(self) %= down;
    }
#line 1492 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__left); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__left)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 998 "Int128.xs"
    if (SvOK(rev)) {
        uint128_t a, b;
        if (SvTRUE(rev)) {
            a = SvU128(aTHX_ other);
            b = SvU128x(self);
        }
        else {
            b = SvU128(aTHX_ other);
            a = SvI128x(self);
        }
        RETVAL = newSVi128(aTHX_ (uint128_t)(b > 127 ? 0 : a << b));
    }
    else {
        uint128_t b = SvU128(aTHX_ other);
        RETVAL = SvREFCNT_inc(self);
        SvI128x(self) = (b > 127 ? 0 : SvI128x(self) << b);
    }
#line 1532 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__right); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__right)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 1023 "Int128.xs"
    int128_t a;
    uint128_t b;
#line 1556 "Int128.c"
	SV *	RETVAL;
#line 1026 "Int128.xs"
    if (SvOK(rev)) {
        if (SvTRUE(rev)) {
            a = SvI128(aTHX_ other);
            b = SvU128x(self);
        }
        else {
            b = SvU128(aTHX_ other);
            a = SvI128x(self);
        }
    }
    else {
        a = SvI128x(self);
        b = SvU128(aTHX_ other);
    }
    RETVAL = newSVi128(aTHX_ (b > 127 ? (a >= 0 ? 0 : -1) : a >> b));
#line 1574 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__pow)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1049 "Int128.xs"
    int sign;
    uint128_t r;
    int128_t a, b;
#line 1598 "Int128.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1053 "Int128.xs"
    if (SvTRUE(rev)) {
        a = SvI128(aTHX_ other);
        b = SvI128x(self);
    }
    else {
        a = SvI128x(self);
        b = SvI128(aTHX_ other);
    }
    if (a < 0) {
        sign = ((b & 1) ? -1 : 1);
        a = -a;
    }
    else sign = 1;
    if (b < 0) {
        if      (a == 0) croak_string(aTHX_ div_by_0_error);
        else if (a == 1) r = sign;
        else             r = 0;
    }
    else {
        uint128_t u = powU128(aTHX_ a, b);
        if (may_die_on_overflow && (u > ((sign < 0) ? (~(uint128_t)INT128_MIN + 1) : INT128_MAX))) overflow(aTHX_ pow_error);
        r = ((sign > 0) ? u : -u);
    }
    if (SvOK(rev))
        RETVAL = newSVi128(aTHX_ r);
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI128x(self) = r;
    }
#line 1638 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__spaceship); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__spaceship)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 1092 "Int128.xs"
    int128_t left;
    int128_t right;
#line 1662 "Int128.c"
	int	RETVAL;
	dXSTARG;
#line 1095 "Int128.xs"
    if (SvTRUE(rev)) {
        left = SvI128(aTHX_ other);
        right = SvI128x(self);
    }
    else {
        left = SvI128x(self);
        right = SvI128(aTHX_ other);
    }
    RETVAL = (left < right ? -1 : left > right ? 1 : 0);
#line 1675 "Int128.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__eqn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__eqn)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self, other, ...");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	RETVAL;
#line 1112 "Int128.xs"
    RETVAL = ( SvI128x(self) == SvI128(aTHX_ other)
               ? &PL_sv_yes
               : &PL_sv_no );
#line 1699 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__nen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__nen)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self, other, ...");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	RETVAL;
#line 1123 "Int128.xs"
    RETVAL = ( SvI128x(self) != SvI128(aTHX_ other)
               ? &PL_sv_yes
               : &PL_sv_no );
#line 1723 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__gtn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__gtn)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1135 "Int128.xs"
    if (SvTRUE(rev))
        RETVAL = SvI128x(self) < SvI128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvI128x(self) > SvI128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 1750 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__ltn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__ltn)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1148 "Int128.xs"
    if (SvTRUE(rev))
        RETVAL = SvI128x(self) > SvI128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvI128x(self) < SvI128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 1777 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__gen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__gen)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1161 "Int128.xs"
    if (SvTRUE(rev))
        RETVAL = SvI128x(self) <= SvI128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvI128x(self) >= SvI128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 1804 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__len)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1174 "Int128.xs"
    if (SvTRUE(rev))
        RETVAL = SvI128x(self) >= SvI128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvI128x(self) <= SvI128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 1831 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__and); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__and)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1187 "Int128.xs"
    if (SvOK(rev))
        RETVAL = newSVi128(aTHX_ SvI128x(self) & SvI128(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI128x(self) &= SvI128(aTHX_ other);
    }
#line 1861 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__or); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__or)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1203 "Int128.xs"
    if (SvOK(rev))
        RETVAL = newSVi128(aTHX_ SvI128x(self) | SvI128(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI128x(self) |= SvI128(aTHX_ other);
    }
#line 1891 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__xor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__xor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1219 "Int128.xs"
    if (SvOK(rev))
        RETVAL = newSVi128(aTHX_ SvI128x(self) ^ SvI128(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI128x(self) ^= SvI128(aTHX_ other);
    }
#line 1921 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__not)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1233 "Int128.xs"
    RETVAL = SvI128x(self) ? &PL_sv_no : &PL_sv_yes;
#line 1941 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__bnot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__bnot)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1241 "Int128.xs"
    RETVAL = newSVi128(aTHX_ ~SvI128x(self));
#line 1961 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__neg)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1249 "Int128.xs"
    RETVAL = newSVi128(aTHX_ -SvI128x(self));
#line 1981 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__bool); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__bool)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1257 "Int128.xs"
    RETVAL = SvI128x(self) ? &PL_sv_yes : &PL_sv_no;
#line 2001 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__number)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1265 "Int128.xs"
    RETVAL = si128_to_number(aTHX_ self);
#line 2021 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__clone)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1273 "Int128.xs"
    RETVAL = newSVi128(aTHX_ SvI128x(self));
#line 2041 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128__string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128__string)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1281 "Int128.xs"
    RETVAL = newSV(I128STRLEN);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, i128_to_string(SvI128x(self), SvPVX(RETVAL)));
#line 2063 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__inc)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1295 "Int128.xs"
    if (may_die_on_overflow && (SvU128x(self) == UINT128_MAX)) overflow(aTHX_ inc_error);
    SvU128x(self)++;
    RETVAL = SvREFCNT_inc(self);
#line 2085 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__dec)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1305 "Int128.xs"
    if (may_die_on_overflow && (SvU128x(self) == 0)) overflow(aTHX_ dec_error);
    SvU128x(self)--;
    RETVAL = SvREFCNT_inc(self);
#line 2107 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 1317 "Int128.xs"
    uint128_t a = SvU128x(self);
    uint128_t b = SvU128(aTHX_ other);
#line 2131 "Int128.c"
	SV *	RETVAL;
#line 1320 "Int128.xs"
    if (may_die_on_overflow && (UINT128_MAX - a < b)) overflow(aTHX_ add_error);
    if (SvOK(rev)) 
        RETVAL = newSVu128(aTHX_ a + b);
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU128x(self) = a + b;
    }
#line 2142 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 1337 "Int128.xs"
    uint128_t a, b;
#line 2165 "Int128.c"
	SV *	RETVAL;
#line 1339 "Int128.xs"
    if (SvTRUE(rev)) {
        a = SvU128(aTHX_ other);
        b = SvU128x(self);
    }
    else {
        a = SvU128x(self);
        b = SvU128(aTHX_ other);
    }
    if (may_die_on_overflow && (b > a)) overflow(aTHX_ sub_error);
    if (SvOK(rev))
        RETVAL = newSVu128(aTHX_ a - b);
    else {
        RETVAL = SvREFCNT_inc(self);
        SvU128x(self) = a - b;
    }
#line 2183 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 1363 "Int128.xs"
    uint128_t a = SvU128x(self);
    uint128_t b = SvU128(aTHX_ other);
#line 2207 "Int128.c"
	SV *	RETVAL;
#line 1366 "Int128.xs"
    if (may_die_on_overflow)
        mul_check_overflow(aTHX_ a, b, mul_error);
    if (SvOK(rev))
        RETVAL = newSVu128(aTHX_ a * b);
    else {
        RETVAL = SvREFCNT_inc(self);
        SvU128x(self) = a * b;
    }
#line 2218 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 1383 "Int128.xs"
    uint128_t up;
    uint128_t down;
#line 2242 "Int128.c"
	SV *	RETVAL;
#line 1386 "Int128.xs"
    if (SvOK(rev)) {
        if (SvTRUE(rev)) {
            up = SvU128(aTHX_ other);
            down = SvU128x(self);
        }
        else {
            up = SvU128x(self);
            down = SvU128(aTHX_ other);
        }
        if (!down)
            croak_string(aTHX_ div_by_0_error);
        RETVAL = newSVu128(aTHX_ up/down);
    }
    else {
        down = SvU128(aTHX_ other);
        if (!down)
            croak_string(aTHX_ div_by_0_error);
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU128x(self) /= down;
    }
#line 2266 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__remainder); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__remainder)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 1416 "Int128.xs"
    uint128_t up;
    uint128_t down;
#line 2290 "Int128.c"
	SV *	RETVAL;
#line 1419 "Int128.xs"
    if (SvOK(rev)) {
        if (SvTRUE(rev)) {
            up = SvU128(aTHX_ other);
            down = SvU128x(self);
        }
        else {
            up = SvU128x(self);
            down = SvU128(aTHX_ other);
        }
        if (!down)
            croak_string(aTHX_ div_by_0_error);
        RETVAL = newSVu128(aTHX_ up % down);
    }
    else {
        down = SvU128(aTHX_ other);
        if (!down)
            croak_string(aTHX_ div_by_0_error);
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU128x(self) %= down;
    }
#line 2314 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__left); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__left)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1448 "Int128.xs"
    if (SvOK(rev)) {
        uint128_t a, b;
        if (SvTRUE(rev)) {
            a = SvU128(aTHX_ other);
            b = SvU128x(self);
        }
        else {
            b = SvU128(aTHX_ other);
            a = SvU128x(self);
        }
        RETVAL = newSVu128(aTHX_ (b > 128 ? 0 : a << b));
    }
    else {
        uint128_t b = SvU128(aTHX_ other);
        RETVAL = SvREFCNT_inc(self);
        SvU128x(self) = (b > 127 ? 0 : SvU128x(self) << b);
    }
#line 2354 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__right); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__right)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1473 "Int128.xs"
    if (SvOK(rev)) {
        uint128_t a, b;
        if (SvTRUE(rev)) {
            a = SvU128(aTHX_ other);
            b = SvU128x(self);
        }
        else {
            b = SvU128(aTHX_ other);
            a = SvU128x(self);
        }
        RETVAL = newSVu128(aTHX_ (b > 127 ? 0 : a >> b));
    }
    else {
        uint128_t b = SvU128(aTHX_ other);
        RETVAL = SvREFCNT_inc(self);
        SvU128x(self) = (b > 127 ? 0 : SvU128x(self) >> b);
    }
#line 2394 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__pow)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1498 "Int128.xs"
    uint128_t r;
    int128_t a, b;
#line 2417 "Int128.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1501 "Int128.xs"
    if (SvTRUE(rev)) {
        a = SvU128(aTHX_ other);
        b = SvU128x(self);
    }
    else {
        a = SvU128x(self);
        b = SvU128(aTHX_ other);
    }
    r = powU128(aTHX_ a, b);
    if (SvOK(rev))
        RETVAL = newSVu128(aTHX_ r);
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU128x(self) = r;
    }
#line 2443 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__spaceship); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__spaceship)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
#line 1526 "Int128.xs"
    uint128_t left;
    uint128_t right;
#line 2467 "Int128.c"
	int	RETVAL;
	dXSTARG;
#line 1529 "Int128.xs"
    if (SvTRUE(rev)) {
        left = SvU128(aTHX_ other);
        right = SvU128x(self);
    }
    else {
        left = SvU128x(self);
        right = SvU128(aTHX_ other);
    }
    RETVAL = (left < right ? -1 : left > right ? 1 : 0);
#line 2480 "Int128.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__eqn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__eqn)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self, other, ...");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	RETVAL;
#line 1546 "Int128.xs"
    RETVAL = ( SvU128x(self) == SvU128(aTHX_ other)
               ? &PL_sv_yes
               : &PL_sv_no );
#line 2504 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__nen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__nen)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self, other, ...");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	RETVAL;
#line 1557 "Int128.xs"
    RETVAL = ( SvU128x(self) != SvU128(aTHX_ other)
               ? &PL_sv_yes
               : &PL_sv_no );
#line 2528 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__gtn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__gtn)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1569 "Int128.xs"
    if (SvTRUE(rev))
        RETVAL = SvU128x(self) < SvU128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvU128x(self) > SvU128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 2555 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__ltn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__ltn)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1582 "Int128.xs"
    if (SvTRUE(rev))
        RETVAL = SvU128x(self) > SvU128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvU128x(self) < SvU128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 2582 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__gen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__gen)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1595 "Int128.xs"
    if (SvTRUE(rev))
        RETVAL = SvU128x(self) <= SvU128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvU128x(self) >= SvU128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 2609 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__len)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1608 "Int128.xs"
    if (SvTRUE(rev))
        RETVAL = SvU128x(self) >= SvU128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvU128x(self) <= SvU128(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 2636 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__and); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__and)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1621 "Int128.xs"
    if (SvOK(rev))
        RETVAL = newSVu128(aTHX_ SvU128x(self) & SvU128(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU128x(self) &= SvU128(aTHX_ other);
    }
#line 2666 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__or); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__or)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1637 "Int128.xs"
    if (SvOK(rev))
        RETVAL = newSVu128(aTHX_ SvU128x(self) | SvU128(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU128x(self) |= SvU128(aTHX_ other);
    }
#line 2696 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__xor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__xor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, rev");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev = ST(2)
;
	SV *	RETVAL;
#line 1653 "Int128.xs"
    if (SvOK(rev))
        RETVAL = newSVu128(aTHX_ SvU128x(self) ^ SvU128(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU128x(self) ^= SvU128(aTHX_ other);
    }
#line 2726 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__not)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1667 "Int128.xs"
    RETVAL = SvU128x(self) ? &PL_sv_no : &PL_sv_yes;
#line 2746 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__bnot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__bnot)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1675 "Int128.xs"
    RETVAL = newSVu128(aTHX_ ~SvU128x(self));
#line 2766 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__neg)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1683 "Int128.xs"
    RETVAL = newSVu128(aTHX_ -SvU128x(self));
#line 2786 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__bool); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__bool)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1691 "Int128.xs"
    RETVAL = SvU128x(self) ? &PL_sv_yes : &PL_sv_no;
#line 2806 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__number)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1699 "Int128.xs"
    RETVAL = su128_to_number(aTHX_ self);
#line 2826 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__clone)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1707 "Int128.xs"
    RETVAL = newSVu128(aTHX_ SvU128x(self));
#line 2846 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt128__string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt128__string)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1715 "Int128.xs"
    RETVAL = newSV(I128STRLEN);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, u128_to_string(SvU128x(self), SvPVX(RETVAL)));
#line 2868 "Int128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int128_int128_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_set)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, a=NULL");
    {
	SV *	self = ST(0)
;
	SV *	a;

	if (items < 2)
	    a = NULL;
	else {
	    a = ST(1)
;
	}
#line 1730 "Int128.xs"
    SvI128x(self) = (a ? SvI128(aTHX_ a) : 0);
#line 2895 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_inc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, a");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
#line 1737 "Int128.xs"
    if ( may_die_on_overflow && (a == INT128_MAX)) overflow(aTHX_ inc_error);
    SvI128x(self) = a + 1;
#line 2915 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_dec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, a");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
#line 1745 "Int128.xs"
    if ( may_die_on_overflow && (a == INT128_MIN)) overflow(aTHX_ dec_error);
    SvI128x(self) = a - 1;
#line 2935 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1754 "Int128.xs"
    if ( may_die_on_overflow &&
         ( a > 0
           ? ( (b > 0) && (INT128_MAX - a < b) )
           : ( (b < 0) && (INT128_MIN - a > b) ) ) ) overflow(aTHX_ add_error);
    SvI128x(self) = a + b;
#line 2960 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1766 "Int128.xs"
    if ( may_die_on_overflow &&
         ( a > 0
           ? ( (b < 0) && (a - INT128_MAX > b) )
           : ( (b > 0) && (a - INT128_MIN < b) ) ) ) overflow(aTHX_ sub_error);
    SvI128x(self) = a - b;
#line 2985 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a1, b1");
    {
	SV *	self = ST(0)
;
	int128_t	a1 = SvI128(aTHX_ ST(1))
;
	int128_t	b1 = SvI128(aTHX_ ST(2))
;
#line 1778 "Int128.xs"
    if (may_die_on_overflow) {
        int neg = 0;
        uint128_t a, b;
        if (a1 < 0) {
            a = -a1;
            neg ^= 1;
        }
        else a = a1;
        if (b1 < 0) {
            b = -b1;
            neg ^= 1;
        }
        else b = b1;
        if (a < b) {
            uint128_t tmp = a;
            a = b; b = tmp;
        }
        mul_check_overflow(aTHX_ a, b, mul_error);
        if (a * b > (neg ? (~(uint128_t)INT128_MIN + 1) : INT128_MAX)) overflow(aTHX_ mul_error);
    }
    SvI128x(self) = a1 * b1;
#line 3026 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_pow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1806 "Int128.xs"
    int sign;
    uint128_t r;
#line 3048 "Int128.c"
#line 1809 "Int128.xs"
    if (a < 0) {
        sign = ((b & 1) ? -1 : 1);
        a = -a;
    }
    else sign = 1;
    if (b < 0) {
        if      (a == 0) croak_string(aTHX_ div_by_0_error);
        else if (a == 1) r = sign;
        else             r = 0;
    }
    else {
        uint128_t u = powU128(aTHX_ a, b);
        if (may_die_on_overflow && (u > ((sign < 0) ? (~(uint128_t)INT128_MIN + 1) : INT128_MAX))) overflow(aTHX_ pow_error);
        r = ((sign > 0) ? u : -u);
    }
    SvI128x(self) = r;
#line 3066 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1832 "Int128.xs"
    if (!b) croak_string(aTHX_ div_by_0_error);
    SvI128x(self) = a / b;
#line 3088 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_mod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_mod)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1841 "Int128.xs"
    if (!b) croak_string(aTHX_ div_by_0_error);
    SvI128x(self) = a % b;
#line 3110 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_divmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_divmod)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, rem, a, b");
    {
	SV *	self = ST(0)
;
	SV *	rem = ST(1)
;
	int128_t	a = SvI128(aTHX_ ST(2))
;
	int128_t	b = SvI128(aTHX_ ST(3))
;
#line 1851 "Int128.xs"
    int128_t d;
#line 3133 "Int128.c"
#line 1853 "Int128.xs"
    if (!b) croak_string(aTHX_ div_by_0_error);
    SvI128x(self) = d = a / b;
    SvI128x(rem) = a - b * d;
#line 3138 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_not)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, a");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
#line 1862 "Int128.xs"
    SvI128x(self) = ~a;
#line 3157 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_neg)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, a");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
#line 1869 "Int128.xs"
    SvI128x(self) = -a;
#line 3176 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_and); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_and)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1877 "Int128.xs"
    SvI128x(self) = a & b;
#line 3197 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_or); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_or)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1885 "Int128.xs"
    SvI128x(self) = a | b;
#line 3218 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_xor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_xor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1893 "Int128.xs"
    SvI128x(self) = a ^ b;
#line 3239 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_left); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_left)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 1901 "Int128.xs"
    SvI128x(self) = (b > 127 ? 0 : a << b);
#line 3260 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_right); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_right)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 1909 "Int128.xs"
    SvI128x(self) = (b > 127 ? (a < 0 ? - 1 : 0) : a >> b);
#line 3281 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_average); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_average)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1917 "Int128.xs"
    SvI128x(self) = (a & b) + ((a ^ b) / 2);
#line 3302 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_min)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1925 "Int128.xs"
    SvI128x(self) = (a > b ? b : a);
#line 3323 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_int128_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_int128_max)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	int128_t	a = SvI128(aTHX_ ST(1))
;
	int128_t	b = SvI128(aTHX_ ST(2))
;
#line 1933 "Int128.xs"
    SvI128x(self) = (a > b ? a : b);
#line 3344 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_set)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, a=0");
    {
	SV *	self = ST(0)
;
	uint128_t	a;

	if (items < 2)
	    a = 0;
	else {
	a = SvU128(aTHX_ ST(1))
;
	}
#line 1944 "Int128.xs"
    SvU128x(self) = a;
#line 3369 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_inc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, a");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
#line 1951 "Int128.xs"
    if ( may_die_on_overflow && (a == INT128_MAX)) overflow(aTHX_ inc_error);
    SvU128x(self) = a + 1;
#line 3389 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_dec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, a");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
#line 1959 "Int128.xs"
    if ( may_die_on_overflow && (a == 0)) overflow(aTHX_ dec_error);
    SvU128x(self) = a - 1;
#line 3409 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 1968 "Int128.xs"
    if (may_die_on_overflow && (UINT128_MAX - a < b)) overflow(aTHX_ add_error);
    SvU128x(self) = a + b;
#line 3431 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 1977 "Int128.xs"
    if (may_die_on_overflow && (b > a)) overflow(aTHX_ sub_error);
    SvU128x(self) = a - b;
#line 3453 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 1986 "Int128.xs"
    if (may_die_on_overflow)
        mul_check_overflow(aTHX_ a, b, mul_error);
    SvU128x(self) = a * b;
#line 3476 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_pow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 1996 "Int128.xs"
    SvU128x(self) = powU128(aTHX_ a, b);
#line 3497 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 2004 "Int128.xs"
    if (!b) croak_string(aTHX_ div_by_0_error);
    SvU128x(self) = a / b;
#line 3519 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_mod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_mod)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 2013 "Int128.xs"
    if (!b) croak_string(aTHX_ div_by_0_error);
    SvU128x(self) = a % b;
#line 3541 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_divmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_divmod)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, rem, a, b");
    {
	SV *	self = ST(0)
;
	SV *	rem = ST(1)
;
	uint128_t	a = SvU128(aTHX_ ST(2))
;
	uint128_t	b = SvU128(aTHX_ ST(3))
;
#line 2023 "Int128.xs"
    uint128_t d;
#line 3564 "Int128.c"
#line 2025 "Int128.xs"
    if (!b) croak_string(aTHX_ div_by_0_error);
    SvU128x(self) = d = a / b;
    SvU128x(rem) = a - b * d;
#line 3569 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_not)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, a");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
#line 2034 "Int128.xs"
    SvU128x(self) = ~a;
#line 3588 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_neg)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, a");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
#line 2041 "Int128.xs"
    SvU128x(self) = -a;
#line 3607 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_and); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_and)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 2049 "Int128.xs"
    SvU128x(self) = a & b;
#line 3628 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_or); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_or)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 2057 "Int128.xs"
    SvU128x(self) = a | b;
#line 3649 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_xor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_xor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 2065 "Int128.xs"
    SvU128x(self) = a ^ b;
#line 3670 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_left); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_left)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 2073 "Int128.xs"
    SvU128x(self) = (b > 127 ? 0 : a << b);
#line 3691 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_right); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_right)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 2081 "Int128.xs"
    SvU128x(self) = (b > 127 ? 0 : a >> b);
#line 3712 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_uint128_average); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_uint128_average)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 2089 "Int128.xs"
    SvU128x(self) = (a & b) + ((a ^ b) >> 1);
#line 3733 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_mi128_uint128_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_mi128_uint128_min)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 2097 "Int128.xs"
    SvU128x(self) = (a > b ? b : a);
#line 3754 "Int128.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int128_mi128_uint128_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int128_mi128_uint128_max)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, a, b");
    {
	SV *	self = ST(0)
;
	uint128_t	a = SvU128(aTHX_ ST(1))
;
	uint128_t	b = SvU128(aTHX_ ST(2))
;
#line 2105 "Int128.xs"
    SvU128x(self) = (a > b ? a : b);
#line 3775 "Int128.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Math__Int128); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__Int128)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Math::Int128::CLONE", XS_Math__Int128_CLONE);
        newXS_deffile("Math::Int128::_set_may_die_on_overflow", XS_Math__Int128__set_may_die_on_overflow);
        newXS_deffile("Math::Int128::int128", XS_Math__Int128_int128);
        newXS_deffile("Math::Int128::uint128", XS_Math__Int128_uint128);
        newXS_deffile("Math::Int128::int128_to_number", XS_Math__Int128_int128_to_number);
        newXS_deffile("Math::Int128::uint128_to_number", XS_Math__Int128_uint128_to_number);
        newXS_deffile("Math::Int128::net_to_int128", XS_Math__Int128_net_to_int128);
        newXS_deffile("Math::Int128::net_to_uint128", XS_Math__Int128_net_to_uint128);
        newXS_deffile("Math::Int128::int128_to_net", XS_Math__Int128_int128_to_net);
        newXS_deffile("Math::Int128::uint128_to_net", XS_Math__Int128_uint128_to_net);
        newXS_deffile("Math::Int128::native_to_int128", XS_Math__Int128_native_to_int128);
        newXS_deffile("Math::Int128::native_to_uint128", XS_Math__Int128_native_to_uint128);
        newXS_deffile("Math::Int128::int128_to_native", XS_Math__Int128_int128_to_native);
        newXS_deffile("Math::Int128::uint128_to_native", XS_Math__Int128_uint128_to_native);
        newXS_deffile("Math::Int128::uint128_to_hex", XS_Math__Int128_uint128_to_hex);
        newXS_deffile("Math::Int128::int128_to_hex", XS_Math__Int128_int128_to_hex);
        newXS_deffile("Math::Int128::string_to_int128", XS_Math__Int128_string_to_int128);
        newXS_deffile("Math::Int128::string_to_uint128", XS_Math__Int128_string_to_uint128);
        newXS_deffile("Math::Int128::_inc", XS_Math__Int128__inc);
        newXS_deffile("Math::Int128::_dec", XS_Math__Int128__dec);
        newXS_deffile("Math::Int128::_add", XS_Math__Int128__add);
        newXS_deffile("Math::Int128::_sub", XS_Math__Int128__sub);
        newXS_deffile("Math::Int128::_mul", XS_Math__Int128__mul);
        newXS_deffile("Math::Int128::_div", XS_Math__Int128__div);
        newXS_deffile("Math::Int128::_remainder", XS_Math__Int128__remainder);
        newXS_deffile("Math::Int128::_left", XS_Math__Int128__left);
        newXS_deffile("Math::Int128::_right", XS_Math__Int128__right);
        newXS_deffile("Math::Int128::_pow", XS_Math__Int128__pow);
        newXS_deffile("Math::Int128::_spaceship", XS_Math__Int128__spaceship);
        newXS_deffile("Math::Int128::_eqn", XS_Math__Int128__eqn);
        newXS_deffile("Math::Int128::_nen", XS_Math__Int128__nen);
        newXS_deffile("Math::Int128::_gtn", XS_Math__Int128__gtn);
        newXS_deffile("Math::Int128::_ltn", XS_Math__Int128__ltn);
        newXS_deffile("Math::Int128::_gen", XS_Math__Int128__gen);
        newXS_deffile("Math::Int128::_len", XS_Math__Int128__len);
        newXS_deffile("Math::Int128::_and", XS_Math__Int128__and);
        newXS_deffile("Math::Int128::_or", XS_Math__Int128__or);
        newXS_deffile("Math::Int128::_xor", XS_Math__Int128__xor);
        newXS_deffile("Math::Int128::_not", XS_Math__Int128__not);
        newXS_deffile("Math::Int128::_bnot", XS_Math__Int128__bnot);
        newXS_deffile("Math::Int128::_neg", XS_Math__Int128__neg);
        newXS_deffile("Math::Int128::_bool", XS_Math__Int128__bool);
        newXS_deffile("Math::Int128::_number", XS_Math__Int128__number);
        newXS_deffile("Math::Int128::_clone", XS_Math__Int128__clone);
        newXS_deffile("Math::Int128::_string", XS_Math__Int128__string);
        newXS_deffile("Math::UInt128::_inc", XS_Math__UInt128__inc);
        newXS_deffile("Math::UInt128::_dec", XS_Math__UInt128__dec);
        newXS_deffile("Math::UInt128::_add", XS_Math__UInt128__add);
        newXS_deffile("Math::UInt128::_sub", XS_Math__UInt128__sub);
        newXS_deffile("Math::UInt128::_mul", XS_Math__UInt128__mul);
        newXS_deffile("Math::UInt128::_div", XS_Math__UInt128__div);
        newXS_deffile("Math::UInt128::_remainder", XS_Math__UInt128__remainder);
        newXS_deffile("Math::UInt128::_left", XS_Math__UInt128__left);
        newXS_deffile("Math::UInt128::_right", XS_Math__UInt128__right);
        newXS_deffile("Math::UInt128::_pow", XS_Math__UInt128__pow);
        newXS_deffile("Math::UInt128::_spaceship", XS_Math__UInt128__spaceship);
        newXS_deffile("Math::UInt128::_eqn", XS_Math__UInt128__eqn);
        newXS_deffile("Math::UInt128::_nen", XS_Math__UInt128__nen);
        newXS_deffile("Math::UInt128::_gtn", XS_Math__UInt128__gtn);
        newXS_deffile("Math::UInt128::_ltn", XS_Math__UInt128__ltn);
        newXS_deffile("Math::UInt128::_gen", XS_Math__UInt128__gen);
        newXS_deffile("Math::UInt128::_len", XS_Math__UInt128__len);
        newXS_deffile("Math::UInt128::_and", XS_Math__UInt128__and);
        newXS_deffile("Math::UInt128::_or", XS_Math__UInt128__or);
        newXS_deffile("Math::UInt128::_xor", XS_Math__UInt128__xor);
        newXS_deffile("Math::UInt128::_not", XS_Math__UInt128__not);
        newXS_deffile("Math::UInt128::_bnot", XS_Math__UInt128__bnot);
        newXS_deffile("Math::UInt128::_neg", XS_Math__UInt128__neg);
        newXS_deffile("Math::UInt128::_bool", XS_Math__UInt128__bool);
        newXS_deffile("Math::UInt128::_number", XS_Math__UInt128__number);
        newXS_deffile("Math::UInt128::_clone", XS_Math__UInt128__clone);
        newXS_deffile("Math::UInt128::_string", XS_Math__UInt128__string);
        newXS_deffile("Math::Int128::int128_set", XS_Math__Int128_int128_set);
        newXS_deffile("Math::Int128::int128_inc", XS_Math__Int128_int128_inc);
        newXS_deffile("Math::Int128::int128_dec", XS_Math__Int128_int128_dec);
        newXS_deffile("Math::Int128::int128_add", XS_Math__Int128_int128_add);
        newXS_deffile("Math::Int128::int128_sub", XS_Math__Int128_int128_sub);
        newXS_deffile("Math::Int128::int128_mul", XS_Math__Int128_int128_mul);
        newXS_deffile("Math::Int128::int128_pow", XS_Math__Int128_int128_pow);
        newXS_deffile("Math::Int128::int128_div", XS_Math__Int128_int128_div);
        newXS_deffile("Math::Int128::int128_mod", XS_Math__Int128_int128_mod);
        newXS_deffile("Math::Int128::int128_divmod", XS_Math__Int128_int128_divmod);
        newXS_deffile("Math::Int128::int128_not", XS_Math__Int128_int128_not);
        newXS_deffile("Math::Int128::int128_neg", XS_Math__Int128_int128_neg);
        newXS_deffile("Math::Int128::int128_and", XS_Math__Int128_int128_and);
        newXS_deffile("Math::Int128::int128_or", XS_Math__Int128_int128_or);
        newXS_deffile("Math::Int128::int128_xor", XS_Math__Int128_int128_xor);
        newXS_deffile("Math::Int128::int128_left", XS_Math__Int128_int128_left);
        newXS_deffile("Math::Int128::int128_right", XS_Math__Int128_int128_right);
        newXS_deffile("Math::Int128::int128_average", XS_Math__Int128_int128_average);
        newXS_deffile("Math::Int128::int128_min", XS_Math__Int128_int128_min);
        newXS_deffile("Math::Int128::int128_max", XS_Math__Int128_int128_max);
        newXS_deffile("Math::Int128::uint128_set", XS_Math__Int128_uint128_set);
        newXS_deffile("Math::Int128::uint128_inc", XS_Math__Int128_uint128_inc);
        newXS_deffile("Math::Int128::uint128_dec", XS_Math__Int128_uint128_dec);
        newXS_deffile("Math::Int128::uint128_add", XS_Math__Int128_uint128_add);
        newXS_deffile("Math::Int128::uint128_sub", XS_Math__Int128_uint128_sub);
        newXS_deffile("Math::Int128::uint128_mul", XS_Math__Int128_uint128_mul);
        newXS_deffile("Math::Int128::uint128_pow", XS_Math__Int128_uint128_pow);
        newXS_deffile("Math::Int128::uint128_div", XS_Math__Int128_uint128_div);
        newXS_deffile("Math::Int128::uint128_mod", XS_Math__Int128_uint128_mod);
        newXS_deffile("Math::Int128::uint128_divmod", XS_Math__Int128_uint128_divmod);
        newXS_deffile("Math::Int128::uint128_not", XS_Math__Int128_uint128_not);
        newXS_deffile("Math::Int128::uint128_neg", XS_Math__Int128_uint128_neg);
        newXS_deffile("Math::Int128::uint128_and", XS_Math__Int128_uint128_and);
        newXS_deffile("Math::Int128::uint128_or", XS_Math__Int128_uint128_or);
        newXS_deffile("Math::Int128::uint128_xor", XS_Math__Int128_uint128_xor);
        newXS_deffile("Math::Int128::uint128_left", XS_Math__Int128_uint128_left);
        newXS_deffile("Math::Int128::uint128_right", XS_Math__Int128_uint128_right);
        newXS_deffile("Math::Int128::uint128_average", XS_Math__Int128_uint128_average);
        newXS_deffile("Math::Int128::mi128_uint128_min", XS_Math__Int128_mi128_uint128_min);
        newXS_deffile("Math::Int128::mi128_uint128_max", XS_Math__Int128_mi128_uint128_max);

    /* Initialisation Section */

#line 553 "Int128.xs"
    init_stash_cache(aTHX);
    PERL_MATH_INT64_LOAD_OR_CROAK;
    INIT_C_API;

#line 3928 "Int128.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
